<?php
foreach ( glob( trailingslashit( get_template_directory() ) . 'inc/*' ) as $filename ) {
	require_once $filename;
}
require ( trailingslashit( get_template_directory() ) . 'inc/theme-update-checker.php');
add_theme_support( 'post-thumbnails' );
add_theme_support('title-tag');
add_theme_support( 'automatic-feed-links' );
add_theme_support( 'html5', array( 'search-form', 'comment-list', 'comment-form', 'gallery', 'caption' ) );
if ( ! isset( $content_width ) ) {
	$content_width = 779.99;
}
load_theme_textdomain( 'memphis', get_template_directory() . '/languages' );
function qdo_register_theme_customizer($wp_customize)
{
    // Customize title and tagline sections and labels
    $wp_customize->get_section('title_tagline')->title   = __('Site Name and Description', 'memphis');
    $wp_customize->get_control('blogname')->label        = __('Site Name', 'memphis');
    $wp_customize->get_control('blogdescription')->label = __('Site Description', 'memphis');
    
    // Customize the Front Page Settings
    $wp_customize->get_section('static_front_page')->title    = __('Homepage Preferences', 'memphis');
    $wp_customize->get_section('static_front_page')->priority = 20;
    $wp_customize->get_control('show_on_front')->label        = __('Choose Homepage Preference', 'memphis');
    $wp_customize->get_control('page_on_front')->label        = __('Select Homepage', 'memphis');
    $wp_customize->get_control('page_for_posts')->label       = __('Select Blog Homepage', 'memphis');
	
	// Customize Background Settings
	$wp_customize->get_section('background_image')->title = __('Background Styles', 'memphis');  
	$wp_customize->get_control('background_color')->section = 'background_image';
	
    // Customize Header Image Settings  
    $wp_customize->add_section('header_text_styles', array(
        'title' => __('Header Text Styles', 'memphis'),
        'priority' => 30
    ));
    $wp_customize->get_control('display_header_text')->section = 'header_text_styles';
    $wp_customize->get_control('header_textcolor')->section    = 'header_text_styles';
    $wp_customize->get_control('header_textcolor')->label      = __('Site Title Color', 'memphis');
    $wp_customize->get_setting('header_textcolor')->transport  = 'postMessage';
    
    // Post Style Setting
    $wp_customize->add_section('post_title_styles', array(
        'title' => __('Post Title Style', 'memphis'),
        'panel' => 'design_settings',
        'priority' => 100
    ));    
    $wp_customize->add_setting('qdo_post_title_color', array(
        'default' => '#8e8e8e',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_post_title_font_size', array(
        'default' => '20px',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_post_title_font_type', array(
        'default' => 'Montserrat',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_post_title_font_weight', array(
        'default' => '400',
        'sanitize_callback' => 'sanitize_text'
    ));
    
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'custom_post_title_color', array(
        'label' => __('Color', 'memphis'),
        'section' => 'post_title_styles',
        'settings' => 'qdo_post_title_color'
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_post_title_font_size', array(
        'label' => __('Font Size', 'memphis'),
        'section' => 'post_title_styles',
        'settings' => 'qdo_post_title_font_size',
        'type' => 'select',
        'choices' => array(
            '20' => '20px',
            '22' => '22px',
            '28' => '28px',
            '32' => '32px',
            '42' => '42px'
        )
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_post_title_font_type', array(
        'label' => __('Font Family', 'memphis'),
        'section' => 'post_title_styles',
        'settings' => 'qdo_post_title_font_type',
        'type' => 'text'
    )));
    
    
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_post_title_font_weight', array(
        'label' => __('Font Weight', 'memphis'),
        'section' => 'post_title_styles',
        'settings' => 'qdo_post_title_font_weight',
        'type' => 'text'
        
    )));
 
    $wp_customize->add_section('post_body_styles', array(
        'title' => __('Post Body Style', 'memphis'),
        'panel' => 'design_settings',
        'priority' => 200
    ));
    
    $wp_customize->add_setting('qdo_post_body_color', array(
        'default' => '#3a3a3a',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_post_body_font_size', array(
        'default' => '13px',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_post_body_font_type', array(
        'default' => 'Lato',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_post_body_font_weight', array(
        'default' => '300',
        'sanitize_callback' => 'sanitize_text'
    ));
    
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'post_body_color', array(
        'label' => __('Color', 'memphis'),
        'section' => 'post_body_styles',
        'settings' => 'qdo_post_body_color'
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'post_body_font_size', array(
        'label' => __('Font Size', 'memphis'),
        'section' => 'post_body_styles',
        'settings' => 'qdo_post_body_font_size',
        'type' => 'select',
        'choices' => array(
            '12' => '12px',
            '13' => '13px',
            '14' => '14px',
            '16' => '16px',
            '18' => '18px'
        )
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'post_body_font_type', array(
        'label' => __('Font Family', 'memphis'),
        'section' => 'post_body_styles',
        'settings' => 'qdo_post_body_font_type',
        'type' => 'text'
    )));
    
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'post_body_font_weight', array(
        'label' => __('Font Weight', 'memphis'),
        'section' => 'post_body_styles',
        'settings' => 'qdo_post_body_font_weight',
        'type' => 'text'
        
    )));  
	
    // Sidebar Style Setting
    $wp_customize->add_section('sidebar_title_styles', array(
        'title' => __('Sidebar & Footer Title Style', 'memphis'),
        'panel' => 'design_settings',
        'priority' => 300
    ));    
    $wp_customize->add_setting('qdo_sidebar_title_color', array(
        'default' => '#8e8e8e',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_sidebar_title_font_size', array(
        'default' => '18px',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_sidebar_title_font_type', array(
        'default' => 'Montserrat',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_sidebar_font_weight', array(
        'default' => '400',
        'sanitize_callback' => 'sanitize_text'
    ));
    
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'custom_sidebar_title_color', array(
        'label' => __('Color', 'memphis'),
        'section' => 'sidebar_title_styles',
        'settings' => 'qdo_sidebar_title_color'
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_sidebar_title_font_size', array(
        'label' => __('Font Size', 'memphis'),
        'section' => 'sidebar_title_styles',
        'settings' => 'qdo_sidebar_title_font_size',
        'type' => 'select',
        'choices' => array(
            '20' => '20px',
            '22' => '22px',
            '28' => '28px',
            '32' => '32px',
            '42' => '42px'
        )
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_sidebar_title_font_type', array(
        'label' => __('Font Family', 'memphis'),
        'section' => 'sidebar_title_styles',
        'settings' => 'qdo_sidebar_title_font_type'
    )));
    
    
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_sidebar_title_font_weight', array(
        'label' => __('Font Weight', 'memphis'),
        'section' => 'sidebar_title_styles',
        'settings' => 'qdo_sidebar_title_font_weight',
        'type' => 'text'
        
    )));
 
    $wp_customize->add_section('sidebar_body_styles', array(
        'title' => __('Sidebar & Footer Body Style', 'memphis'),
        'panel' => 'design_settings',
        'priority' => 400
    ));
    
    $wp_customize->add_setting('qdo_sidebar_body_color', array(
        'default' => '#3a3a3a',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_sidebar_body_font_size', array(
        'default' => '13px',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_sidebar_body_font_type', array(
        'default' => 'Lato',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_setting('qdo_sidebar_body_font_weight', array(
        'default' => '300',
        'sanitize_callback' => 'sanitize_text'
    ));
    
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'custom_sidebar_body_color', array(
        'label' => __('Color', 'memphis'),
        'section' => 'sidebar_body_styles',
        'settings' => 'qdo_post_body_color'
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_sidebar_body_font_size', array(
        'label' => __('Font Size', 'memphis'),
        'section' => 'sidebar_body_styles',
        'settings' => 'qdo_sidebar_body_font_size',
        'type' => 'select',
        'choices' => array(
            '12' => '12px',
            '14' => '14px',
            '16' => '16px',
            '18' => '18px'
        )
    )));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_sidebar_body_font_type', array(
        'label' => __('Font Family', 'memphis'),
        'section' => 'sidebar_body_styles',
        'settings' => 'qdo_sidebar_body_font_type'
    )));
    
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_sidebar_body_font_weight', array(
        'label' => __('Font Weight', 'memphis'),
        'section' => 'sidebar_body_styles',
        'settings' => 'qdo_sidebar_body_font_weight',
        'type' => 'text'
        
    )));  
	
    // Footer Text
    $wp_customize->add_section('footer_text', array(
        'title' => __('Copyright Setting', 'memphis'),
        'panel' => 'copyright_settings',
        'priority' => 1000
    ));
    $wp_customize->add_setting('footer_text', array(
        'default' => 'All Rights Reserved',
        'sanitize_callback' => 'sanitize_text'
    ));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'footer_text', array(
        'label' => __('Copyright Text', 'memphis'),
        'section' => 'footer_text',
        'setting' => 'footer_text',
        'type' => 'text'
    )));
    
    // Add Custom CSS Textfield
    $wp_customize->add_section('custom_css_field', array(
        'title' => __('Custom CSS', 'memphis'),
        'panel' => 'design_settings',
        'priority' => 2000
    ));
    $wp_customize->add_setting('qdo_custom_css', array(
        'sanitize_callback' => 'sanitize_textarea'
    ));
    $wp_customize->add_control(new WP_Customize_Control($wp_customize, 'custom_css', array(
        'label' => __('Add custom CSS here', 'memphis'),
        'section' => 'custom_css_field',
        'settings' => 'qdo_custom_css',
        'type' => 'textarea'
    )));
	
	// Slider Setting
	$wp_customize->add_section('slider_setting', array(
			'title'       => __( 'Slider Settings', 'memphis' ),
			'panel' => 'design_settings',
			'priority'    => 1000,
			'description' => __('Change slider settings here.', 'memphis'),
		) 
	);
		$wp_customize->add_setting( 'show_slider', array(
			'default'        => false,
			'transport'  =>  'refresh',
			'sanitize_callback' => 'sanitize_checkbox'
		) );

	$wp_customize->add_control('show_slider', array(
				'label'     => __('Show Slider?','memphis'),
				'section'   => 'slider_setting',
				'setting' => 'show_slider',
				'type'      => 'checkbox'
		)
	);	
    
    // Create custom panels
    $wp_customize->add_panel('general_settings', array(
        'priority' => 10,
        'theme_supports' => '',
        'title' => __('General Settings', 'memphis'),
        'description' => __('Controls the basic settings for the theme.', 'memphis')
    ));
    $wp_customize->add_panel('design_settings', array(
        'priority' => 20,
        'theme_supports' => '',
        'title' => __('Design Settings', 'memphis'),
        'description' => __('Controls the basic design settings for the theme.', 'memphis')
    ));
    $wp_customize->add_panel('copyright_settings', array(
        'theme_supports' => '',
        'title' => __('Copyright Settings', 'memphis'),
        'description' => __('Copyright settings for the theme.', 'memphis')
    ));
    
    // Assign sections to panels
    $wp_customize->get_section('title_tagline')->panel      = 'general_settings';
    //$wp_customize->get_section('nav')->panel = 'general_settings';
	$wp_customize->get_section('background_image')->panel = 'design_settings';
	$wp_customize->get_section('background_image')->priority = 1000;
    $wp_customize->get_section('header_text_styles')->panel = 'design_settings';
    $wp_customize->get_section('header_image')->panel       = 'design_settings';
	
}
add_action('customize_register', 'qdo_register_theme_customizer');
// Theme Custom Header Image
$defaults = array(
    'default-image' => get_template_directory_uri() . '/images/header.png',
    'default-text-color' => '#000000',
    'header-text' => true,
    'uploads' => true,
    'wp-head-callback' => 'qdo_style_header'
);
add_theme_support('custom-header', $defaults);

// Callback function for updating header styles
function qdo_style_header()
{
    
    $text_color = get_header_textcolor();
    
?>
  
  <style type="text/css">

  .header .title a {
    color: #<?php
    echo esc_attr($text_color);
?>;
  }
  
  <?php
    if (display_header_text() != true):
?>
  .header .blog-title, .header .blog-desc {
    display: none;
  } 
  <?php
    endif;
?>
 
  .post-title {
	font: <?php
    echo get_theme_mod('qdo_post_title_font_weight');
?> <?php
    echo get_theme_mod('qdo_post_title_font_size');
?>px <?php
    echo get_theme_mod('qdo_post_title_font_type');
?>;
   }
  .post-title a {
    color: <?php
    echo get_theme_mod('qdo_post_title_color');
?>;
  }
  .post-body {
	font: <?php echo get_theme_mod('qdo_post_body_font_weight'); ?> <?php echo get_theme_mod('qdo_post_body_font_size');?>px <?php echo get_theme_mod('qdo_post_body_font_type'); ?>;
    color: <?php
    echo get_theme_mod('qdo_post_body_color');
?>;
  }
    .sidebar h3, .footer h3 {
	font: <?php
    echo get_theme_mod('qdo_sidebar_title_font_weight');
?> <?php
    echo get_theme_mod('qdo_sidebar_title_font_size');
?>px <?php
    echo get_theme_mod('qdo_sidebar_title_font_type');
?>;
    color: <?php
    echo get_theme_mod('qdo_sidebar_title_color');
?>;
  }
    .sidebar, .sidebar a, .footer, .footer a {
	font: <?php
    echo get_theme_mod('qdo_sidebar_body_font_weight');
?> <?php
    echo get_theme_mod('qdo_sidebar_body_font_size');
?> <?php
    echo get_theme_mod('qdo_sidebar_body_font_type');
?>;
    color: <?php
    echo get_theme_mod('qdo_sidebar_body_color');
?>;
  }
  h1 {
    font-size: <?php
    echo get_theme_mod('qdo_h1_font_size');
?>px;
  }
  h1 a {
    color: <?php
    echo get_theme_mod('qdo_h1_color');
?>;
  }

  <?php
    if (get_theme_mod('qdo_custom_css') != '') {
        echo get_theme_mod('qdo_custom_css');
    }
?>

  </style>
  <?php
    
}

// Add theme support for Custom Backgrounds
$defaults = array(
  'default-color' => '#ffffff',
  'default-image' => get_template_directory_uri() . '',  
  'default-repeat' => 'no-repeat', 
  'default-position' => 'center top', 
);
add_theme_support( 'custom-background', $defaults );

// Sanitize text 
function sanitize_text($text)
{
    
    return sanitize_text_field($text);
    
}

// Sanitize textarea 
function sanitize_textarea($text)
{
    
    return esc_textarea($text);
    
}

// Sanitize checkbox
function sanitize_checkbox( $input ) {
	if ( $input == 1 ) {
		return 1;
	} else {
		return '';
	}
}

// Custom js for theme customizer
function qdo_customizer_js()
{
    wp_enqueue_script('qdo_theme_customizer', get_template_directory_uri() . '/js/theme-customizer.js', array(
        'jquery',
        'customize-preview'
    ), '', true);
}
add_action('customize_preview_init', 'qdo_customizer_js');

// Theme font
if ( ! function_exists( 'qdo_fonts_url' ) ) :
function qdo_fonts_url() {
	$fonts_url = '';
	$fonts     = array();
	$subsets   = 'latin,latin-ext';

	if ( 'off' !== _x( 'on', 'Lato font: on or off', 'memphis' ) ) {
		$fonts[] = 'Lato:100,300,400,700,900,400italic,700italic,900italic';
	}

	if ( 'off' !== _x( 'on', 'Montserrat font: on or off', 'memphis' ) ) {
		$fonts[] = 'Montserrat:400,700';
	}

	if ( 'off' !== _x( 'on', 'Playfair Display font: on or off', 'memphis' ) ) {
		$fonts[] = 'Playfair Display:400,700,900,400italic,700italic,900italic';
	}

	if ( $fonts ) {
		$fonts_url = add_query_arg( array(
			'family' => urlencode( implode( '|', $fonts ) ),
			'subset' => urlencode( $subsets ),
		), 'https://fonts.googleapis.com/css' );
	}

	return $fonts_url;
}
endif;
add_editor_style( array( 'css/editor-style.css', qdo_fonts_url() ) );

// Theme Stylesheets
function theme_styles()
{
	wp_enqueue_style( 'memphis-fonts', qdo_fonts_url(), array(), null );
    wp_enqueue_style('bootstrap_css', get_template_directory_uri() . '/css/bootstrap.min.css');
    wp_enqueue_style('fontawesome_css', get_template_directory_uri() . '/css/font-awesome.min.css');
    wp_enqueue_style('main_css', get_template_directory_uri() . '/style.css');
}
add_action('wp_enqueue_scripts', 'theme_styles');

// Theme Comments Reply
function theme_comments_reply() {
	if( get_option( 'thread_comments' ) )  {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'comment_form_before', 'theme_comments_reply' );

// Theme Scripts
function theme_js()
{
    global $wp_scripts;
    wp_register_script('html5_shiv', 'https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js', '', '', false);
    wp_register_script('respond_js', 'https://oss.maxcdn.com/respond/1.4.2/respond.min.js', '', '', false);
    $wp_scripts->add_data('html5_shiv', 'conditional', 'lt IE9');
    $wp_scripts->add_data('respond_js', 'conditional', 'lt IE9');
    wp_enqueue_script('bootstrap_js', get_template_directory_uri() . '/js/bootstrap.min.js', array(
        'jquery'
    ), '', true);
    wp_enqueue_script('main_js', get_template_directory_uri() . '/js/main.js', array(
        'jquery'
    ), '', true);
}
add_action('wp_enqueue_scripts', 'theme_js');

// Theme Menu
add_theme_support('menus');
function theme_menus()
{
    register_nav_menus(array(
        'header-menu' => __('Header Menu', 'memphis'),
        'social-menu' => __('Social Menu', 'memphis')
    ));
}
add_action('widgets_init', 'theme_menus');

// Theme Widgets
function theme_widgets()
{
    register_sidebar(array(
        'name' => __('Right Sidebar Widget', 'memphis'),
        'id' => ('right-sidebar'),
        'description' => __('Display on right sidebar', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
    register_sidebar(array(
        'name' => __('Left Sidebar Widget', 'memphis'),
        'id' => ('left-sidebar'),
        'description' => __('Display on left sidebar', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
    register_sidebar(array(
        'name' => __('Left Footer Widget', 'memphis'),
        'id' => ('left-footer'),
        'description' => __('Display on left of the footer', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
    register_sidebar(array(
        'name' => __('Right Footer Widget', 'memphis'),
        'id' => ('right-footer'),
        'description' => __('Display on right of the footer', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
    register_sidebar(array(
        'name' => __('Center Footer Widget', 'memphis'),
        'id' => ('center-footer'),
        'description' => __('Display on center of the footer', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
    register_sidebar(array(
        'name' => __('Error Section', 'memphis'),
        'id' => ('error'),
        'description' => __('Display on 404 Page', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
    register_sidebar(array(
        'name' => __('Landing Page Section', 'memphis'),
        'id' => ('landing-page'),
        'description' => __('Display on Landing Page', 'memphis'),
        'before_widget' => '<div class="widget">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3>'
    ));
}
add_action( 'widgets_init', 'theme_widgets' );

// Theme Read More Hook
function modify_read_more_link() {
    return '<a class="read-more" href="' . get_permalink() . '">Read More</a>';
}
add_filter( 'the_content_more_link', 'modify_read_more_link' );

// Theme Recent Post
Class qdo_Recent_Posts_Widget extends WP_Widget_Recent_Posts {

        function widget($args, $instance) {

                if ( ! isset( $args['widget_id'] ) ) {
                $args['widget_id'] = $this->id;
            }

            $title = ( ! empty( $instance['title'] ) ) ? $instance['title'] : __( 'Recent Posts', 'memphis' );

            /** This filter is documented in wp-includes/widgets/class-wp-widget-pages.php */
            $title = apply_filters( 'widget_title', $title, $instance, $this->id_base );

            $number = ( ! empty( $instance['number'] ) ) ? absint( $instance['number'] ) : 5;
            if ( ! $number )
                $number = 5;
            $show_date = isset( $instance['show_date'] ) ? $instance['show_date'] : false;

            /**
             * Filter the arguments for the Recent Posts widget.
             *
             * @since 3.4.0
             *
             * @see WP_Query::get_posts()
             *
             * @param array $args An array of arguments used to retrieve the recent posts.
             */
            $r = new WP_Query( apply_filters( 'widget_posts_args', array(
                'posts_per_page'      => $number,
                'no_found_rows'       => true,
                'post_status'         => 'publish',
                'ignore_sticky_posts' => true
            ) ) );

            if ($r->have_posts()) :
            ?>
            <?php echo $args['before_widget']; ?>
            <?php if ( $title ) {
                echo $args['before_title'] . $title . $args['after_title'];
            } ?>
            <ul class="recent-post">
            <?php while ( $r->have_posts() ) : $r->the_post(); ?>
                <li class="clearfix">
					<div class="col-xs-5 recent-img padding-0">
						<?php the_post_thumbnail(array(140, 104)); ?>
					</div>
					<div class="col-xs-7 recent-summary">
						<a href="<?php the_permalink(); ?>"><?php get_the_title() ? the_title() : the_ID(); ?></a>
						<?php if ( $show_date ) : ?>
							<div class="post-meta hidden-xs"><div class="post-pub"><?php the_time('M j, Y'); ?></div></div>
						<?php endif; ?>
					</div>
                </li>
            <?php endwhile; ?>
            </ul>
            <?php echo $args['after_widget']; ?>
            <?php
            // Reset the global $the_post as this query will have stomped on it
            wp_reset_postdata();

            endif;
        }
}
function qdo_recent_widget_registration() {
  unregister_widget('WP_Widget_Recent_Posts');
  register_widget('qdo_recent_posts_widget');
}
add_action('widgets_init', 'qdo_recent_widget_registration');

// Theme Popular Post
function popularpost($postID) {
    $countKey = 'post_views_count';
    $count = get_post_meta($postID, $countKey, true);
    if($count==''){
        $count = 0;
        delete_post_meta($postID, $countKey);
        add_post_meta($postID, $countKey, '0');
    }else{
        $count++;
        update_post_meta($postID, $countKey, $count);
    }
};

// Theme Breadcrumb
function breadcrumb() {
		echo '<ol class="breadcrumb hidden-sm hidden-xs">';
	if (!is_home()) {
		echo '<li><a href="';
		echo home_url();
		echo '">';
		echo 'Home';
		echo "</a></li>";
		if (is_category() || is_single()) {
			echo '<li>';
			the_category(' </li><li> ');
			if (is_single()) {
				echo "</li><li>";
				the_title();
				echo '</li>';
			}
		} elseif (is_page()) {
			echo '<li>';
			echo the_title();
			echo '</li>';
		}
	}
	echo '</ol>';
}

// Theme Pagination
if ( ! function_exists( 'pagination' ) ) :
	function pagination() {
		global $wp_query;

		$big = 999999999; // need an unlikely integer
		
		echo paginate_links( array(
			'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
			'format' => '?paged=%#%',
			'current' => max( 1, get_query_var('paged') ),
			'show_all'           => false,
			'prev_next'          => true,
			'prev_text'          => __('Previous Articles', 'memphis' ),
			'next_text'          => __('Next Articles', 'memphis' ),
			'type'               => 'list',
			'total' => $wp_query->max_num_pages
		) );
	}
endif;

// Theme featured post custom input
function qdo_custom_meta() {
    add_meta_box( 'qdo_meta', __( 'Featured Posts', 'memphis' ), 'qdo_meta_callback', 'post' );
}
function qdo_meta_callback( $post ) {
    $featured = get_post_meta( $post->ID );
	
    ?>
 
	<p>
    <div class="sm-row-content">
        <label for="meta-checkbox">
            <input type="checkbox" name="meta-checkbox" id="meta-checkbox" value="yes" <?php if ( isset ( $featured['meta-checkbox'] ) ) checked( $featured['meta-checkbox'][0], 'yes' ); ?> />
            <?php _e( 'Featured this post', 'memphis' )?>
        </label>
        
    </div>
</p>
 
    <?php
}
add_action( 'add_meta_boxes', 'qdo_custom_meta' );
function qdo_meta_save( $post_id ) {
 
    // Checks save status
    $is_autosave = wp_is_post_autosave( $post_id );
    $is_revision = wp_is_post_revision( $post_id );
    $is_valid_nonce = ( isset( $_POST[ 'qdo_nonce' ] ) && wp_verify_nonce( $_POST[ 'qdo_nonce' ], basename( __FILE__ ) ) ) ? 'true' : 'false';
 
    // Exits script depending on save status
    if ( $is_autosave || $is_revision || !$is_valid_nonce ) {
        return;
    }
 
 // Checks for input and saves
if( isset( $_POST[ 'meta-checkbox' ] ) ) {
    update_post_meta( $post_id, 'meta-checkbox', 'yes' );
} else {
    update_post_meta( $post_id, 'meta-checkbox', '' );
}
 
}
add_action( 'save_post', 'qdo_meta_save' );

// Theme required and recommanded plugins
function qdo_register_required_plugins() {
	$plugins = array(
		array(
			'name'        => 'WordPress SEO by Yoast',
			'slug'        => 'wordpress-seo',
			'is_callable' => 'wpseo_init',
		),
		array(
			'name'        => 'Regenerate Thumbnails',
			'slug'        => 'regenerate-thumbnails',
			'required'     => true,
			'is_callable' => 'wprethumb_init',
		),
		array(
			'name'        => 'Contact Form 7',
			'slug'        => 'contact-form-7',
			'required'     => true,
			'is_callable' => 'wpform7_init',
		),
		array(
			'name'        => 'Instagram Slider Widget',
			'slug'        => 'instagram-slider-widget',
			'required'     => true,
			'is_callable' => 'wpinsta_init',
		),
		array(
			'name'        => 'MailChimp for WordPress',
			'slug'        => 'mailchimp-for-wp',
			'required'     => true,
			'is_callable' => 'wpmc_init',
		)
	);
	$config = array(
		'id'           => 'memphis',    // Unique ID for hashing notices for multiple instances of TGMPA.
		'default_path' => '',                      // Default absolute path to bundled plugins.
		'menu'         => 'tgmpa-install-plugins', // Menu slug.
		'parent_slug'  => 'themes.php',            // Parent menu slug.
		'capability'   => 'edit_theme_options',    // Capability needed to view plugin install page, should be a capability associated with the parent menu used.
		'has_notices'  => true,                    // Show admin notices or not.
		'dismissable'  => true,                    // If false, a user cannot dismiss the nag message.
		'dismiss_msg'  => '',                      // If 'dismissable' is false, this message will be output at top of nag.
		'is_automatic' => true,                   // Automatically activate plugins after installation or not.
		'message'      => '',                     // Message to output right before the plugins table.
	);
	tgmpa( $plugins, $config );
}
add_action( 'tgmpa_register', 'qdo_register_required_plugins' );

// Theme Update Checker
$qdo_update_checker = new ThemeUpdateChecker(
	'memphis',                                            //Theme folder name, AKA "slug". 
	'http://www.qdonow.com/theme-update/memphis/info.json' //URL of the metadata file.
);
?>